/***
 * 文档地址 http://shyaf-artist-platform.suggest.vip/swagger-ui.html#/
 * **/

//生产环境
const host = "https://artist-platform.artouchstone.com/";

//开发环境
// const host = "https://platform-dev.artouchstone.com/artist/";  

//const host = "http://192.168.0.33:8080/";

const socket="wss://cmcstudymp.suggest.vip/websocket/course/ware/study/";



const api = {

  socket:socket,

  apiName: `api_url`, //注释

  //code 换取 wxcode
  code:`api/weixin/sdk/ma/WxMaCommandController/code2session`,

  //获取用户token
  getUserToken:`api/weixin/sdk/ma/WxMaCommandController/getUserToken`,

  //登录
  login:"api/auth/sdk/loginByUserToken",

  //微信小程序更新并创建微信用户
  updateWxUserInfo:`/api/weixin/sdk/ma/WxMaCommandController/updateWxUserInfo`,

  //上传文件
  upload:"api/file/sdk/upload",

  //获取销售方信息
  findSale:"api/sale/SaleInfoRestReadFacade/findSale",

  //获取销售方列表
  querySale:"api/sale/SaleInfoRestReadFacade/querySale",

  //删除销售方信息
  removeSale:"api/sale/SaleInfoRestWriteFacade/removeSale",

  //新增/更新销售方
  updateSale:"api/sale/SaleInfoRestWriteFacade/updateSale",




  //艺术家开票身份验证
  updateArtistUserInvoice:"api/artist/ArtistUserRestWriteFacade/updateArtistUserInvoice",

  //艺术家开票合同模板下载
  downloadArtistUserInvoice:"api/contract/ContractRestWriteFacade/downloadArtistUserInvoice",

  //艺术家开票合同上传
  uploadArtistUserInvoice:"api/contract/ContractRestWriteFacade/uploadArtistUserInvoice",

  //开票信息填写
  addInvoice:"api/invoice/InvoiceRestWriteFacade/addInvoice",

  //获取发票抬头列表
  queryInvoiceBuy:"api/invoice/InvoiceRestReadFacade/queryInvoiceBuy",

  //发票订单信息列表
  queryOrderInvoiceBuy:"api/order/InvoiceOrderRestReadFacade/queryInvoiceBuy",

  //获取发票订单详细信息
  queryOrderInvoiceInfo:"api/invoice/InvoiceRestReadFacade/queryInvoiceInfo",

  //更新发票订单状态
  updateInvoiceOrder:"api/order/InvoiceOrderRestWriteFacade/updateInvoiceOrder",

  //获取服务费发票信息
  queryInvoiceServiceInfo:"api/invoice/InvoiceRestReadFacade/queryInvoiceServiceInfo",

  //开具服务费发票
  updateInvoiceServiceOrder:"api/order/InvoiceOrderRestWriteFacade/updateInvoiceServiceOrder",

  //学历字典接口
  findByCode:"api/DicReadFacade/findByCode",

  findTreeByType:"api/CategoryRestReadFacade/findTreeByType",

  //通过id查找作品详情
  artFindById:"api/OpusRestReadFacade/findById",

  //查询用户的作品列表
  artFindPage:"api/OpusRestReadFacade/findPage",

  //新增作品
  artAdd:"api/OpusRestWriteFacade/add",

  //更新作品
  artUpdate:"api/OpusRestWriteFacade/update",

  //获取基本信息(个人中心页展示)
  getBaseInfo:"api/UserRestReadFacade/getBaseInfo",

  //获取详细公司入驻信息
  getCompanySettledInfo:"api/UserRestReadFacade/getCompanySettledInfo",

  //获取消息
  getMessage:"api/UserRestReadFacade/getMessage",

  //获取详细个人入驻信息
  getPersonalSettledInfo:"api/UserRestReadFacade/getPersonalSettledInfo",

  //获取用户的一些认证信息
  getUserSettleInfo:"api/UserRestReadFacade/getUserSettleInfo",

  //添加(更新)公司详情
  addCompanyDetails:"api/UserRestWriteFacade/addCompanyDetails",

  //添加(更新)个人详情
  addPersonalDetails: "/api/UserRestWriteFacade/addPersonalDetails",

  // 同意协议  员工0 企业1 策展2 SettledTypeEnum
  agreement:"api/UserRestWriteFacade/agreement",

  readMsg:"api/UserRestWriteFacade/readMsg",

  getBanner:"api/BannerRestReadFacade/findList",

  getUserPhone:"api/weixin/sdk/ma/WxMaCommandController/getUserPhone",

  //服务留资
  addLeaveInfo:"api/LeaveInfoRestWriteFacade/add",

  //物流追踪
  findExpressList:"api/express/InvoiceExpressReadFacade/findExpressList",

  /**
   * 邀请函
   * add by yangkun 20211023
   */
  InvitationSave: "api/InvitesFacade/add", // 登记信息提交
  InvitationUpdate: "/api/InvitesFacade/update", // 登记信息修改
  InvitationGet: "/api/InvitesFacade/findByUid", // 个人登记信息查询
  InvitationGetId: "/api/InvitesFacade/findById", // 管理登记信息查询
  InvitationVerification: "api/InvitesFacade/updateInvites" // 登记信息核销
};

const apiInit={};
Object.keys(api).forEach(key => {
  apiInit[key]=`${host}${api[key]}`
});

apiInit.socket=socket;

export default apiInit;

