// pages/invoice/downContract/downContract.js
const app = getApp();
const api = app.api;
import WxValidate from '../../../utils/WxValidate'

Page({

  /**
   * 页面的初始数据
   */
  data: {
    formData:{
      email:""
    },
    rules: {
      email: {
        required: true,
        email:true
      },
    },
    messages: {
      email: {
        required: '请输入邮箱'
      }
    },
    isSubmit:false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const { rules, messages } = this.data;
    this.WxValidate = new WxValidate(rules, messages);
  },
  saveData() {
    const {formData,isSubmit} = this.data;
        // console.log(this.WxValidate.checkForm(formData));
    if(isSubmit){
      return
    }
    // 传入表单数据，调用验证方法
    if (!this.WxValidate.checkForm(formData)) {
      const error = this.WxValidate.errorList[0];
      wx.showToast({
        title: error.msg,
        icon: 'none',
        duration: 2000
      })
      return false
    }
    this.setData({
      isSubmit:true
    });
    app.post(api.downloadArtistUserInvoice, formData).then(res => {
      wx.showToast({
        title: '合同模板已发送到邮箱，请查收',
        duration: 2000
      })
      this.setData({
        isSubmit:false,
      });
      wx.navigateBack();
    }).catch(()=>{
      this.setData({
        isSubmit:false
      });
    })
  },
  changeInput(e){
    console.log(e);
    const id = e.currentTarget.id;
    const value = e.detail.value;
    this.setData({
      [id]: value
    });
  },
  backClose(){
    wx.navigateBack();
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})
