// pages/invoice/editSale/editSale.js
const app = getApp();
const api = app.api;
import WxValidate from '../../../utils/WxValidate'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isShowSimple:false,
    saleId: null,
    formData: {
      identityNumber: "",
      name:"",
      phoneNumber: "",
      certifyFileId:""
    },
    upFileInfo:null,
    rules: {
      name: {
        required: true,
      },
      phoneNumber: {
        required: true,
        tel: true,
      },
      identityNumber: {
        required: true,
        idcard: true,
      },
      certifyFileId:{
        required: true,
      }
    },
    messages: {
      name: {
        required: '请输入姓名',
      },
      phoneNumber: {
        required: '请输入手机号',
        tel: '请输入正确的手机号',
      },
      identityNumber: {
        required: '请输入身份证号码',
        idcard: '请输入正确的身份证号码',
      },
      certifyFileId:{
        required: '请上传身份证',
      }
    },
    isSubmit:false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log(options)
    this.setData({
      saleId: options.id || null
    });
    // if (this.data.saleId) {
    //   this.getData(this.data.saleId)
    // }
    const { rules, messages } = this.data;
    this.WxValidate = new WxValidate(rules, messages);
    console.log('WxValidate',this.WxValidate)
  },
  changeInput(e){
    console.log(e);
    const id = e.currentTarget.id;
    const value = e.detail.value;
    this.setData({
      [id]: value
    });
    wx.hideShareMenu();
  },
  getData(id) {
    app.post(api.findSale, {
      saleId: id
    }).then(res => {
      let { saleId, name, phoneNumber, identityNumber,certifyFileInfo } = res.data;
      this.setData({
        saleId: saleId,
        upFileInfo:certifyFileInfo,
        formData: {
          name,
          phoneNumber,
          identityNumber,
          certifyFileId:certifyFileInfo.id
        }
      })
    })
  },
  saveData() {
    const {formData,saleId,upFileInfo,isSubmit} = this.data;
    if(isSubmit){
      return
    }
    if (saleId) {
      formData.saleId = saleId
    }
    // console.log(this.WxValidate.checkForm(formData));
    // 传入表单数据，调用验证方法
    if (!this.WxValidate.checkForm(formData)) {
      const error = this.WxValidate.errorList[0];
      wx.showToast({
        title: error.msg,
        icon: 'none',
        duration: 2000
      })
      return false
    }

    console.log(this.WxValidate);
    this.setData({
      isSubmit:true
    })
    app.post(api.updateSale, formData).then(res => {
      wx.showToast({
        title: '添加成功',
        duration: 2000
      })
      this.setData({
        isSubmit:false,
      });
      wx.navigateBack();
    }).catch(()=>{
      this.setData({
        isSubmit:false
      });
    })

  },
  chooseFile(){
    app.uploadFile().then(res=>{
      console.log(res)
      const data=JSON.parse(res.data);
      this.setData({
        upFileInfo:data,
        'formData.certifyFileId':data.id
      })
    }).catch(error=>{
      console.log(error)
    });
  },
  removeFile(){
    this.setData({
      upFileInfo:null,
      'formData.certifyFileId':'',
    })
  },
  showSimple(){
    this.setData({
      isShowSimple:true
    })
  },
  hideSimple(){
    this.setData({
      isShowSimple:false
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    if (this.data.saleId) {
      this.getData(this.data.saleId)
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})
