// pages/login/login.js
const app = getApp();
const api = app.api;
import regeneratorRuntime from '../../utils/runtime'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    showPopPhone:false,
    wxPhoneEncrypted:null,
    wxUserEncrypted:null
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.removeStorageSync('loginInfo');
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  async bindGetUserInfo(e) {
    const userInfo = await app.getToken();
    this.setData({
      showPopPhone:true
    })
  },
  closePhonePop(){
    this.setData({
      showPopPhone:false
    });
  },
  getPhoneNumber(e){
    console.log(e);
    const that = this;
    that.setData({
      wxPhoneEncrypted:{
        encryptedData: e.detail.encryptedData,
        ivStr: e.detail.iv
      }
    });
    wx.getUserInfo({
      success: function (res) {
        console.log('用户信息',res)
        const {encryptedData,iv} =res
        that.setData({
          wxUserEncrypted:{
            encryptedData,
            ivStr:iv
          }
        },()=>{
          that.saveData();
        });
      }
    });

  },

  async saveData(){
    const {wxUserEncrypted,wxPhoneEncrypted}=this.data;
    const userInfo = await app.getToken();
    app.post(api.updateWxUserInfo,{
      wxUserEncrypted,
      wxPhoneEncrypted
    },{needToken:false}).then(res=>{
      console.log('注册状态',res)
      wx.showToast({
        title:"注册成功",
        duration:2000,
        icon:"none"
      });
      wx.removeStorageSync('loginInfo')
      wx.navigateBack();
    });
  },
  bindBack: function(){
    wx.navigateBack();
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  }

})
