// pages/invoice/authentication/authentication.js
const app = getApp();
const api = app.api;
import WxValidate from '../../../utils/WxValidate'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    businessLicenseFileInfo:null,
    upFileInfoFont:null,
    formData:{
     name:"",
     phoneNumber:"",
     businessLicenseNo:"",
     address:"",
     businessLicenseImgId:""
    },
    rules: {
      name: {
        required: true,
      },
      phoneNumber: {
        required: true,
        phone: true,
      },
      businessLicenseNo:{
        required: true,
      },
      address:{
        required: true,
      },
      businessLicenseImgId:{
        required: true,
      }
    },
    messages: {
      name: {
        required: '请输入公司名',
      },
      businessLicenseNo:{
        required: '请输入公司统一信用代码',
      },
      phoneNumber: {
        required: '公司联系电话',
        phone: '请输入正确的电话',
      },
      address:{
        required: '请输入公司地址',
      },
      businessLicenseImgId:{
        required: '请上传公司营业执照',
      }
    },
    isValidate:false,
    isSubmit:false
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const { rules, messages } = this.data;
    this.WxValidate = new WxValidate(rules, messages);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },
  validateHanlder(){
    const {formData} = this.data;
    if (!this.WxValidate.checkForm(formData)) {
      this.setData({
        isValidate:false
      })
    }else{
      this.setData({
        isValidate:true
      })
    }
  },
  saveData() {
    const {formData,isSubmit} = this.data;
    if(isSubmit){
      return
    }
    // 传入表单数据，调用验证方法
    if (!this.WxValidate.checkForm(formData)) {
      const error = this.WxValidate.errorList[0];
      wx.showToast({
        title: error.msg,
        icon: 'none',
        duration: 2000
      })
      return false
    }
    console.log(this.WxValidate);
    wx.requestSubscribeMessage({
      tmplIds: [
        'EnF59db6rv1QhwUc67GuKNQBw-R-VZNAB5xVXyP40A4',
      ],
      success: (res)=> {
        this.setData({
          isSubmit:true
        });
        app.post(api.addCompanyDetails, formData).then(res => {
          this.setData({
            isSubmit:false,
          });
          wx.redirectTo({
            url:"/pages/settled/success/success"
          })
          //console.log(res);
          /* wx.redirectTo({
             url:"/pages/invoice/contract/contract"
           })*/
        }).catch(()=>{
          this.setData({
            isSubmit:false
          });
        })
      }
    })

  },
  changeInput(e){
    console.log(e);
    const id = e.currentTarget.id;
    const value = e.detail.value;
    this.setData({
      [id]: value
    });
  },
  chooseFile(){
    app.uploadFile({
      extension:['jpg','png','jpeg']
    }).then(res=>{
      console.log(res)
      const data=JSON.parse(res.data);
      this.setData({
        businessLicenseFileInfo:data,
        'formData.businessLicenseImgId':data.id
      },()=>{
        this.validateHanlder();
      })
    }).catch(error=>{
      console.log(error)
    });
  },
  removeChooseFile(){
    this.setData({
      businessLicenseFileInfo:null,
      'formData.businessLicenseImgId':''
    })
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})
