// pages/settled/personInfo/personInfo.js
const app = getApp();
const api = app.api;
import WxValidate from '../../../utils/WxValidate'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    formData:{
      type:2, //策展入驻
      mobile:"",
      email:"",
      address:"",
      weixinNo:""
    },
    rules: {
      mobile: {
        required: true,
        tel:true,
      },
      address:{
        required: true,
      },
      email: {
        required: true,
        email:true
      },
      weixinNo:{
        required: true,
      }
    },
    messages: {
      mobile: {
        required: '请输入手机号',
        tel:"请输入正确的手机号"
      },
      email: {
        required: '请输入邮箱地址',
        email:'请输入邮箱地址'
      },
      address:{
        required: '请输入地址',
      },
      weixinNo:{
        required: '请输入微信号',
      }
    }
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const { rules, messages } = this.data;
    this.WxValidate = new WxValidate(rules, messages);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    const { rules, messages } = this.data;
    this.WxValidate = new WxValidate(rules, messages);
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  saveData() {
    const {formData} = this.data;
    // 传入表单数据，调用验证方法
    if (!this.WxValidate.checkForm(formData)) {
      const error = this.WxValidate.errorList[0];
      wx.showToast({
        title: error.msg,
        icon: 'none',
        duration: 2000
      })
      return false
    }
    console.log(this.WxValidate);
    app.post(api.addPersonalDetails, formData).then(res => {
      console.log(res);
      wx.redirectTo({
        url:"/pages/user/success/success",
      })
      /* wx.redirectTo({
         url:"/pages/invoice/contract/contract"
       })*/
    });
  },
  changeInput(e){
    console.log(e);
    const id = e.currentTarget.id;
    const value = e.detail.value;
    this.setData({
      [id]: value
    });
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})
